/* 
 * File:   formulaBNF.h
 * Author: fran
 *
 * Created on 03 December 2009, 16:13
 */

#ifndef _FORMULABNF_H
#define	_FORMULABNF_H

#include <boost/spirit/include/classic_core.hpp>
#include <boost/spirit/include/classic_ast.hpp>
#include <ecsb/ecsb.h>

using namespace boost::spirit::classic;
using namespace std;

////////////////////////////////////////////////////////////////////////////
//  Our P system BNF grammar
////////////////////////////////////////////////////////////////////////////
struct formulas_p: public grammar<formulas_p>
{
    template <typename ScannerT>
    struct definition
    {
        definition(formulas_p const& /*self*/)
        {
            formulas = root_node_d[str_p("Formulas:")] >>
                        +formula;

            formula = discard_node_d[ch_p('"')] >> root_node_d[formulaSpecification] >> discard_node_d[ch_p('"')] >> !parameters;

            formulaSpecification = token_node_d[+(alnum_p | ch_p('=') | ch_p('?') | space_p | ch_p('[') | ch_p('(') | ch_p(')') | ch_p('_') | ch_p(',') | ch_p(']') | ch_p('>') | ch_p('^') | ch_p('&') | ch_p('<') | ch_p('+') | ch_p('{') | ch_p('}') | ch_p('*') | ch_p('/') | ch_p('$'))] ;// |   | \
                                                      | \
                                                     | \
                                                   |  | \
                                                  )];
            
            parameters =  root_node_d[ch_p('{')] >> 
                          parameterSpecification >>
                          *( discard_node_d[ch_p(',')] >> parameterSpecification) >> 
								  discard_node_d[ch_p('}')];

            parameterSpecification = root_node_d[parameterName] >> discard_node_d[ch_p('=')] >> lowerBound >> discard_node_d[ch_p(':')]
                                                    >> step >> discard_node_d[ch_p(':')]
                                                    >> upperBound;
            parameterName = token_node_d[+(alnum_p | ch_p('$'))];

            lowerBound = real_p;

            step = real_p;

            upperBound = real_p;

        }

        rule<ScannerT> formulas, formula, formulaSpecification, parameters, \
                       parameterSpecification, parameterName, lowerBound, \
                       step, upperBound, alphaNum_p;

        rule<ScannerT> const&
        start() const { return formulas; }
    };
};

#endif	/* _FORMULABNF_H */

