/* 
 * File:   mc2ModelChecker.h
 * Author: fran
 *
 * Created on 09 February 2010, 16:26
 */

#ifndef _MC2MODELCHECKER_H
#define	_MC2MODELCHECKER_H

#include "parameters.h"
#include <mcss/mcss.h>

using namespace Simulation;

namespace PMODELCHECKER{

void useMC2(MCParameters* MCParams);

std::string obtainHead(std::string HDF5file);

void generateSimulationsFileMC2(std::string simulationsHDF5,unsigned long runs,std::string simulationsMC2);

void generateSimulationsFileMC2(std::string simulationParameters,
                                               std::string simulationMC2,
                                               unsigned long numberRuns,
                                               std::string molecularSpecies,
                                               std::string compartments);

void generateSimulationsFromModel(std::string mcssParamsFile, std::string HDF5file, unsigned long runs, std::string simulationsFileMC2);

void checkProperties(std::string MC2Path, std::string simulationsFileMC2, std::string temporalFormulas, std::string resultFile);
    std::map<std::string,
             std::map<std::map<std::string,double>,
                     std::string> > generateFormulas(std::string temporalFormulas, std::string expandedFormulas);

std::map<std::string,std::map<std::map<std::string,double>, std::string> > expandFormulas(iter_t astTree);

std::map< std::map< std::string, double >, std::string > instantiateFormula(std::string formula,
                                std::map< std::string, std::vector<string> > formulaParameters);

std::map< std::map< std::string, double>, std::string > replaceParameter(std::string parameterName,
                      std::string parameterValue,
                      std::map< std::map< std::string, double>, std::string > formulas);


std::string substituteString(std::string formula, std::string parameterName, std::string parameterValue);

void generatePRISMFormat(std::map<std::string,
                                  std::map<std::map<std::string,double>,
                                           std::string> > formulas,
                         std::string resultFile);

//std::string fileToString(std::string fileName);

std::vector<std::string> createVectorCSV(std::string output,std::string token = ",");

std::vector<std::string> getFormulas(std::string temporalFormulas);

std::vector<unsigned long> moleculesToOutput(Psystem *psystem, std::string molecularSpecies);

std::vector<unsigned long> compartmentsToOutput(Psystem *psystem, std::string compartmentPositions);


}


#endif	/* _MC2MODELCHECKER_H */

