// parameter class definitions
// automatically generated by make-parameter-class
// part of libecsb - the executable cell systems biology library
// copyright 2008 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef MODEL_CHECKER_PARAMETERS_H
#define MODEL_CHECKER_PARAMETERS_H

#include <ecsb/ecsb.h>

namespace PMODELCHECKER{

// PRISMParameters class
class MCParameters {

    public:
      // constructor
      MCParameters(void);

      // parameters
      // File containing the P system specification
      std::string model_specification;
      //Model checker specification
      std::string model_checker;
      // File containing the PRISM model
      std::string PRISM_model;
      // Path to the MC2 jar file
      std::string pathMC2;
      // Boolean parameter declaring if the simulations have been already generated in HDF5 format
      std::string simulations_generatedHDF5;
      // Boolean parameter declaring if the simulations have been already generated in MC2 format
      std::string simulations_generatedMC2;
      // File where the simulations from mcss are stored
      std::string simulations_file_hdf5;
      // File with the parameters to run the simulator
      std::string mcss_params_file;
      // Molecular species' names to output
      std::string molecular_species;
      // Positions to output
      std::string positions;
      // File where the simulations in MC2 format are stored
      std::string simulations_file_MC2;
      // File containing the file where to write the variables
      std::string parameters_file;
      // File containing the temporal formulas to check
      std::string temporal_formulas;
      // Parameters of the PRISM model
      std::string model_parameters;
      // File containng values for the parameters in the P system specification and temporal logic formulas
      std::string formula_parameters;
      // Task to perform either translate, build, verify or approximate
      std::string task;
      // Number of simulations to used when approximation is applied
      unsigned long number_samples;
      // Precision used when approximating the answer to a formula
      float precision;
      // Confidence level used when approximating the answer to a formula
      float confidence;
      // File containing the states of our model
      std::string states_file;
      // File containing the transitions of our model
      std::string transitions_file;
      // File containing the results of model checking or approximating the asked formulas
      std::string results_file;

      //Read parameters from xml file
      void read(std::string xmlFile);

      //Read parameters from xml file and command line
      void read(int argc, char **argv);

      // set a parameter value
      bool setParameter(std::string, std::string);
};

}

#endif
