/*
 * Date (yymmdd):               090320
 * Version:                     0.2
 * Written by:                  Dr. Francisco J. Romero-Campero
 * Additional contributions by: Jonathan Blakes
 * (in no particular order)     Dr. Hongqing Cao
 *                              Dr. Natalio Krasnogor
 *				Dr. Jamie Twycross
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
 */

#ifndef _PRISMCOMMAND_H
#define	_PRISMCOMMAND_H

#include<string>

using namespace std;
using namespace ECSB;

namespace PMODELCHECKER{

class PrismCommand {

public:

    PrismCommand();
    PrismCommand(const PrismCommand& orig);
    PrismCommand(int option, std::string moduleName, ECSB::LPPRule rule,
            std::vector<long> position, std::map<std::vector<long>,std::string> positions);
    virtual ~PrismCommand();

    std::string getIdentifier();
    std::string getPredicate();
    std::string getRate();
    std::vector<std::string> getUpdates();
    std::string getRule();

    void show();

protected:

    int effect(string object, ECSB::LPPRule rule);
    void createPredicate(int option, std::string moduleName, ECSB::LPPRule rule,
        std::vector<long> position, std::map<std::vector<long>,std::string> positions);
    void createRate(int option, std::string moduleName, ECSB::LPPRule rule);
    void createUpdates(int option, std::string moduleName, ECSB::LPPRule rule,
            std::vector<long> position, std::map<std::vector<long>,std::string> positions);
    void createRule(ECSB::LPPRule rule);

    int multiplicity(string object, std::vector<std::string> multiset);
    std::string targetModuleName(ECSB::LPPRule rule,
            std::vector<long> position,
            std::map<std::vector<long>,std::string> positions);

private:

    std::string identifier;
    std::string predicate;
    std::string rate;
    std::vector<std::string> updates;
    std::string rule;
    
};

}

#endif	/* _PRISMCOMMAND_H */

