/*
 * Date (yymmdd):               090320
 * Version:                     0.2
 * Written by:                  Dr. Francisco J. Romero-Campero
 * Additional contributions by: Jonathan Blakes
 * (in no particular order)     Dr. Hongqing Cao
 *                              Dr. Natalio Krasnogor
 *				Dr. Jamie Twycross
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
 */

#ifndef _PRISMMODULE_H
#define	_PRISMMODULE_H

#include<map>
#include<string>
#include<vector>
#include<ecsb/ecsb.h>

#include <pmodelchecker/prismvariable.h>
#include <pmodelchecker/prismcommand.h>


using namespace std;
using namespace ECSB;

namespace PMODELCHECKER{

class PrismModule {
public:
    PrismModule();
    PrismModule(const PrismModule& orig);
    PrismModule(std::string moduleName, ECSB::PSystem pSystem, ECSB::LPPCompartment compartment);
    virtual ~PrismModule();

    //Getters
    std::string getName();
    std::map<std::string,PrismVariable> getVariables();
    std::map<std::string,PrismCommand> getCommands();

    void addCommand(PrismCommand command);
    void write(ofstream prismFile);
    void show();

private:
    std::string name;
    std::map<std::string,PrismVariable> variables;
    std::map<std::string,PrismCommand> commands;

};

}

#endif	/* _PRISMMODULE_H */

