/*
 * Date (yymmdd):               090320
 * Version:                     0.2
 * Written by:                  Dr. Francisco J. Romero-Campero
 * Additional contributions by: Jonathan Blakes
 * (in no particular order)     Dr. Hongqing Cao
 *                              Dr. Natalio Krasnogor
 *				Dr. Jamie Twycross
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
 */

#include <pmodelchecker/prismvariable.h>

using namespace ECSB;
 
PrismVariable::PrismVariable()
{
    this->lowerBound = "";
    this->upperBound = "";
}

PrismVariable::PrismVariable(const PrismVariable& orig) {
    this->name = orig.name;
    this->description = orig.description;
    this->lowerBound = orig.lowerBound;
    this->upperBound = orig.upperBound;
    this->initialValue = orig.initialValue;
}

PrismVariable::PrismVariable(std::string variableName,
            std::string variableLowerBound,
            std::string variableUpperBound,
            std::string variableInitialValue)
{
    this->name = variableName;
    this->lowerBound = variableLowerBound;
    this->upperBound = variableUpperBound;
    this->initialValue = variableInitialValue;
}

PrismVariable::~PrismVariable() {
}


//Setters
void PrismVariable::setName(std::string variableName)
{
    this->name = variableName;
}

void PrismVariable::setDescription(std::string variableDescription)
{
    this->description = variableDescription;
}

void PrismVariable::setLowerBound(std::string variableLowerBound)
{
    this->lowerBound = variableLowerBound;
}

void PrismVariable::setUpperBound(std::string variableUpperBound)
{
    this->upperBound = variableUpperBound;
}

void PrismVariable::setInitialValue(std::string variableInitialValue)
{
    this->initialValue = variableInitialValue;
}


//Getters

std::string PrismVariable::getName()
{
    return this->name;
}

std::string PrismVariable::getDescription()
{
    return this->description;
}


std::string PrismVariable::getInitialValue()
{
    return this->initialValue;
}

std::string PrismVariable::getLowerBound()
{
    return this->lowerBound;
}

std::string PrismVariable::getUpperBound()
{
    return this->upperBound;
}

