/*
 * Date (yymmdd):               090320
 * Version:                     0.2
 * Written by:                  Dr. Francisco J. Romero-Campero
 * Additional contributions by: Jonathan Blakes
 * (in no particular order)     Dr. Hongqing Cao
 *                              Dr. Natalio Krasnogor
 *				Dr. Jamie Twycross
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
 */

#ifndef _PRISMVARIABLE_H
#define	_PRISMVARIABLE_H

#include<map>
#include<string>

using namespace std;

namespace ECSB {

class PrismVariable {

public:
    PrismVariable();
    PrismVariable(const PrismVariable& orig);

    PrismVariable(std::string variableName,
            std::string variableLowerBound,
            std::string variableUpperBound,
            std::string variableInitialValue);

    virtual ~PrismVariable();

    //Setters
    void setName(std::string variableName);
    void setDescription(std::string variableDescription);
    void setLowerBound(std::string variableLowerBound);
    void setUpperBound(std::string variableUpperBound);
    void setInitialValue(std::string variableInitialValue);

    //Getters
    std::string getName();
    std::string getDescription();
    std::string getLowerBound();
    std::string getUpperBound();
    std::string getInitialValue();

private:
    std::string name;
    std::string description;
    std::string lowerBound;
    std::string upperBound;
    std::string initialValue;

};

}

#endif	/* _PRISMVARIABLE_H */

