/*
 * Date (yymmdd):               090320
 * Version:                     0.2
 * Written by:                  Dr. Francisco J. Romero-Campero
 * Additional contributions by: Jonathan Blakes
 * (in no particular order)     Dr. Hongqing Cao
 *                              Dr. Natalio Krasnogor
 *				Dr. Jamie Twycross
 * Funded by:                   EPSRC grant EP/E017215/1
 * Website:                     http://www.infobiotic.org/
 * Contact:                     nxk@cs.nott.ac.uk
 */

#include <string>

#if HAVE_CONFIG_H
	#include <config.h>
#endif

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pmodelchecker/parameters.h>

#include <pmodelchecker/pmodelchecker.h>
#include <pmodelchecker/prismModelChecker.h>
#include <pmodelchecker/mc2ModelChecker.h>

using namespace std;
using namespace ECSB;
using namespace PMODELCHECKER;
using namespace boost::spirit::classic;


int main(int argc, char **argv)
{

  //Checking the arguments
  if(argc == 1)
  {
      std::cout << "pmodelchecker version " << VERSION << std::endl;
      std::cout << "usage: pmodelchecker PARAMETER_FILE [PARAMETER=VALUE] ..." << std::endl;
      exit(1);
  }

  //Model checker parameters
  MCParameters* MCParams = new MCParameters();

  //Read the parameters
  MCParams->read(argc,argv);

  if(MCParams->model_checker == "PRISM")
  {
      usePRISM(MCParams);
  }
  else if (MCParams->model_checker == "MC2")
  {
      useMC2(MCParams);
  }

  delete MCParams;

  return 0;
}

